<?PHP
/*-----------------------------------------------------------------------**
---------------------------------------------------------------------------
IPM (Incyte Project Manager)
PHP based project tracking tool 
Copyright (c) 2001 by phlux

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
---------------------------------------------------------------------------
**-----------------------------------------------------------------------*/
											
// FUNCTION LIST

////////// OOP RELATED FUNCTIONS ////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

////////// TASK RELATED FUNCTIONS ////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

function printpriority($priority) {
	switch ($priority) {
		case "crit":
			echo "<font color=red>$priority</font>";
			break;
		case "hi":
			echo "<font color=yellow>$priority</font>";
			break;
		case "std":
			echo "$priority";
			break;
		case "lo":
			echo "<font color=green>$priority</font>";
			break;
	}
}

function printtask_hdr() {
?>
	<tr class=darker>
		<td align=center width=5%>
			HOURS
		</td>
		<td align=center width=5%>
			COMMENTS
		</td>
		<td align=center width=25%>
			TITLE
		</td>
		<td align=center width=55%>
			DESCRIPTION
		</td>
		<td width=5% align=center>
			DUE DATE
		</td>
		<td width=5% align=center>
			PRI
		</td>
		<td width=5% align=center>
			ACTION
		</td>
	</tr>
<?
}

function printtask($task) {
	// Get the URL to the task ($op) interpreter document (index.php)
	global $DOCUMENT_ROOT;
	global $PHP_SELF;
	$nonadminphp = str_replace($DOCUMENT_ROOT, "", dirname($PHP_SELF)) . "/index.php";
	$is_late = (substr($task[enddate],0,4) != "0000" && strtotime($task[enddate]) < time());
?>
	<tr class=lighter valign=top>
		<td align=center>
			<? if (!$task[billable]) {
				 echo $task[hours];
			} else {
				 echo "<font class=billable>$task[hours]</font>";
			} ?>
		</td>
		<td align=center>
			<? if ($task[comments]) {
				 echo "<img src=img/comment-on.gif border=0>";
			} else {
				 echo "<img src=img/comment-off.gif border=0>";
			} ?>
		</td>
		<td>
			<a href=<? echo "$nonadminphp?op=edittask&task_id=$task[task_id]"; ?>><?=$task[title]?></a>
		</td>
		<td>
			<? echo nl2br($task[description]); ?>&nbsp;
		</td>
		<td align=center nowrap>
			<? if ($is_late) { echo "<font color=red><b>"; } ?>
			<? echo prettydate($task[enddate],true); ?>&nbsp;
			<? if ($is_late) { echo "</b></font>"; } ?>
		</td>
		<td align=center nowrap>
			<?printpriority($task[priority]);?>
		</td>
		<td align=center nowrap>
				<a href=<? echo "$nonadminphp?finish=$task[task_id]"; ?>><img src=img/f-on.gif border=0></a> 
				<a href=<? echo "$nonadminphp?op=confirmdeletetask&id=$task[id]&task_id=$task[task_id]"; ?>><img src=img/d-on.gif border=0></a>
		</td>
	</tr>
	<?
}

function printtaskwide_hdr() {
?>
	<tr class=darker> <td align=center width=5%> OWNER
		</td>
		<td align=center width=5%>
				HOURS
		</td>
		<td align=center width=5%>
				COMMENTS
		</td>
		<td align=center width=25%>
				TITLE
		</td>
		<td align=center width=50%>
				DESCRIPTION
		</td>
		<td align=center width=5%>
				DUE DATE
		</td>
		<td width=5% align=center>
				PRI
		</td>
		<td width=5% align=center>
				ACTION
		</td>
	</tr>
<?
}

function printtaskwide($task) {

	// Get the URL to the task ($op) interpreter document (index.php)
	global $DOCUMENT_ROOT;
	global $PHP_SELF;
	$nonadminphp = str_replace($DOCUMENT_ROOT, "", dirname($PHP_SELF)) . "/index.php";
	$is_late = (substr($task[enddate],0,4) != "0000" && strtotime($task[enddate]) < time());

	?>
	<tr class=lighter valign=top>
		<td align=center>
			<?=$task[username]?>
		</td>
		<td align=center>
			<? if (!$task[billable]) {
				 echo $task[hours];
			} else {
				 echo "<font class=billable>$task[hours]</font>";
			} ?>
		</td>
		<td align=center>
			<? if ($task[comments]) {
				 echo "<img src=img/comment-on.gif border=0>";
			} else {
				 echo "<img src=img/comment-off.gif border=0>";
			} ?>
		</td>
		<td>
			<a href=<? echo "$nonadminphp?op=edittask&task_id=$task[task_id]"; ?>><?=$task[title]?></a>
			</font>
		</td>
		<td>
			<? echo nl2br($task[description]); ?>&nbsp;
		</td>
		<td>
			<? if ($is_late) { echo "<font color=red><b>"; } ?>
			<? echo prettydate($task[enddate],true); ?>&nbsp;
			<? if ($is_late) { echo "</b></font>"; } ?>
		</td>
		<td align=center nowrap>
			<?printpriority($task[priority]);?>
		</td>
		<td align=center nowrap>
			<a href=<? echo "$nonadminphp?finish=$task[task_id]"; ?>><img src=img/f-on.gif border=0></a> 
			<a href=<? echo "$nonadminphp?op=confirmdeletetask&id=$task[id]&task_id=$task[task_id]"; ?>><img src=img/d-on.gif border=0></a>
		</td>
	</tr>
<?
}


function dbconnect() {
	// This function makes a connection to the SQL server and grabs the appropriate
	// database for use in all the other functions.
	include ("config.php");
	if (!$db=mysql_connect($db_servername, $db_username, $db_password)) {
		echo "ERROR! UNABLE TO CONNECT TO DATABASE";
	}
	if (!mysql_select_db($db_dbname)) {
		echo "ERROR! UNABLE TO FIND $db_dbname DATABASE";
	}
}

function unauthorized() {
	// If you hit cancel on the authentication screen or you fail 3 times
	// this function is called and displays a message.
	include ("config.php");
	echo "<html><head><link rel=stylesheet type=text/css href=$stylesheet_url>"
			 ."<title>$page_title$version</title></head><body><br><br>";
	message("$unauthorizedmessage"); 
	echo "</body></html>";
}

function logged_out() {
	// If you hit cancel on the authentication screen or you fail 3 times
	// this function is called and displays a message.
	include ("config.php");
	echo "<html><head><link rel=stylesheet type=text/css href=$stylesheet_url>"
			 ."<title>$page_title$version</title></head><body><br><br>";
	message("You are now logged out of IPM"); 
	echo "</body></html>";
}
	
function authenticate() {
  global $uid;
  return $uid;
} 

function isadmin() {
	// Returns true if the logged in user has admin privleges.
	include ("config.php");
	dbconnect();
	$user_id=authenticate();
	$query="SELECT role FROM IPM_users WHERE id='$user_id'";
	$result=mysql_query($query);
	while ($list=mysql_fetch_row($result)){
			if ($list[0] == 1) {
				 return 1;
			} else {
				 return;
			}
	}
}

function dateform($prefix, $year, $month, $day) {
?>
	<select name=<?=$prefix?>month size=1>
<?PHP
	// MySQL doesn't store pretty names for months. So this is my workaround.
	switch ($month) {
		case "01":
			$monthname="Jan";
			break;
		case "02":
			$monthname="Feb";
			break;
		case "03":
			$monthname="Mar";
			break;
		case "04":
			$monthname="Apr";
			break;
	   	case "05":
			$monthname="May";
			break;
		case "06":
			$monthname="Jun";
			break;
		case "07":
			$monthname="Jul";
			break;
		case "08":
			$monthname="Aug";
			break;
		case "09":
			$monthname="Sep";
			break;
		case "10":
			$monthname="Oct";
			break;
		case "11":
			$monthname="Nov";
			break;
		case "12":
			$monthname="Dec";
			break;
	}
	?>
		<option value=<?=$month?> selected><?=$monthname?></option>
		<option value=<?=$month?>>-----</option>
		<option value=01>Jan</option>
		<option value=02>Feb</option>
		<option value=03>Mar</option>
		<option value=04>Apr</option>
		<option value=05>May</option>
		<option value=06>Jun</option>
		<option value=07>Jul</option>
		<option value=08>Aug</option>
		<option value=09>Sep</option>
		<option value=10>Oct</option>
		<option value=11>Nov</option>
		<option value=12>Dec</option>
	</select>
	<select name=<?=$prefix?>day size=1>
		<option value=<?=$day?> selected><?=$day?></option>
		<option value=<?=$day?>>-----</option>
		<option value=01>01</option>
		<option value=02>02</option>
		<option value=03>03</option>
		<option value=04>04</option>
		<option value=05>05</option>
		<option value=06>06</option>
		<option value=07>07</option>
		<option value=08>08</option>
		<option value=09>09</option>
		<option value=10>10</option>
		<option value=11>11</option>
		<option value=12>12</option>
		<option value=13>13</option>
		<option value=14>14</option>
		<option value=15>15</option>
		<option value=16>16</option>
		<option value=17>17</option>
		<option value=18>18</option>
		<option value=19>19</option>
		<option value=20>20</option>
		<option value=21>21</option>
		<option value=22>22</option>
		<option value=23>23</option>
		<option value=24>24</option>
		<option value=25>25</option>
		<option value=26>26</option>
		<option value=27>27</option>
		<option value=28>28</option>
		<option value=29>29</option>
		<option value=30>30</option>
		<option value=31>31</option>
	</select>
	<select name=<?=$prefix?>year size=1>
		<option value=<?=$year?> selected><?=$year?></option>
		<option value=<?=$year?>>-----</option>
		<option value=2001>2001</option>
		<option value=2002>2002</option>
		<option value=2003>2003</option>
		<option value=2003>2004</option>
		<option value=2005>2005</option>
		<option value=2006>2006</option>
		<option value=2007>2007</option>
		<option value=2008>2008</option>
		<option value=2009>2009</option>
	</select>
<?PHP
}

function draw_time_and_progress_bars ($id, $text_class) {
	// FUNCTION SUBMITTED BY: DAVID HUGHES  (David.W.Hughes@cern.ch)
	$timedone = percentTimeComplete($id);
	$workdone = percentcomplete($id);
	echo "<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=0>\n";
	$safe_td = max(0, min(100, $timedone));
	if ($completed) { $safe_td = min(100, $safe_td); }
	if ($completed || $safe_td < $workdone) {
		 // project complete or within schedule
		 $colour = "green";
	} elseif ($timedone < 100) {
		 // within deadline but behind schedule
		 $colour = "yellow";
	} else {
		 // project over deadline
		 $colour = "red";
	}
	if ($timedone <= 0) {
		$timedone="scheduled";
	} elseif ($timedone >= 100) {
		$timedone="<b>overdue</b>";
	} else {
		$timedone="$timedone%&nbsp;time";
	}
	if ($workdone <= 0) {
		$workdone="not started";
	} elseif ($workdone >= 100) {
		$workdone="<b>complete</b>";
	} else {
		$workdone="$workdone%&nbsp;work";
	}
	echo "<TR><TD ALIGN=left $text_class>$timedone</TD><TD>&nbsp;</TD><TD>", drawbar_colour($colour,$safe_td), "</TD></TR>\n";
	echo "<TR><TD ALIGN=left $text_class>$workdone</TD><TD>&nbsp;</TD><TD>", drawbar_colour("green",$workdone), "</TD></TR>\n";
	echo "</TABLE>\n";
}

function drawbar_colour ($colour, $percent) {
	// This function takes the integer (from 0-100) $percent as an argument
	// to build a bargraph using small images. It doesn't depend on the gd lib.
	// safety: normalise $percent if it's not between 0 and 100.
	// FUNCTION SUBMITTED BY: DAVID HUGHES  (David.W.Hughes@cern.ch)

	$percent = max(0, min(100, $percent));
	$l_colour = ($percent == 0   ? "grey" : $colour);
	$r_colour = ($percent == 100 ? $colour : "grey");
	// This is a hack to avoid bad browser behaviour from using <img width=0>
	if ($percent == 0  ) { $percent = 1; }
	if ($percent == 100) { $percent = 99; }
	echo "<img src=img/bars/bar-left-$l_colour.gif border=0 height=12 width=5>";
	echo "<img src=img/bars/bar-tile-$l_colour.gif border=0 height=12 width=", ($percent*2), ">";
	echo "<img src=img/bars/bar-tile-$r_colour.gif border=0 height=12 width=", (200 - $percent*2), ">";
	echo "<img src=img/bars/bar-right-$r_colour.gif border=0 height=12 width=5>\n";
}

function percentTimeComplete($id) {
	// Use built-in MySQL functions to calculate timespan of project and see how
	// far into a project (time-wise) we are.
	// FUNCTION SUBMITTED BY: DAVID HUGHES  (David.W.Hughes@cern.ch)
	dbconnect();
	$query = "SELECT to_days(current_date)-to_days(startdate) AS elapsed, to_days(enddate)-to_days(startdate) AS total, completed FROM IPM_projects WHERE id = $id";
	$result = mysql_query($query);
	$row = mysql_fetch_array($result);
	$elapsed = $row[elapsed];
	$total = $row[total];
	if ($total == 0) {
		 return 100;
	} else {
		 if ((100 * $elapsed / $total) == 0) {
		 		return 0;
		 } else {
		 	  return sprintf("%02d", 100 * $elapsed / $total);
		 }
	}
}

function percentcomplete($id) {
	// This function takes a project id and and compares the todo hours
	// to the finished hours to make a percent done
	dbconnect();
	$Qtodo="SELECT * FROM IPM_tasks WHERE id=$id AND status=1";
	$Qdone="SELECT * FROM IPM_tasks WHERE id=$id AND status=0";
	$Rtodo=mysql_query($Qtodo); 
	$Rdone=mysql_query($Qdone);
	$totaltodo=0;
	$totaldone=0;
	while ($todo=mysql_fetch_array($Rtodo)) 
	{
		$totaltodo=$totaltodo + $todo[hours];
	}
	while ($done=mysql_fetch_array($Rdone))
	{
		$totaldone=$totaldone + $done[hours];
	}
	$totalboth=$totaltodo+$totaldone;
	if ($totalboth > 0) {
	   $percent=100 * ($totaldone / $totalboth);
	   $percentdone = sprintf("%2d",$percent);
	   return $percentdone;
	}else{
	   return $percenttotal;
	}
}

function popuploader($id, $description, $linkname, $url, $class) {
	include "config.php";
  	echo "<a class=$class name=$id href=$url onMouseOver=\"window.status='$linkname'; show('box-$id'); return true;\" onMouseOut=\"hide('box-$id'); return true;\">$linkname</a>";
 	$res= "<DIV ID=box-$id class=hidden>\n"
       ."<table border=1 cellpadding=5 cellspacing=0 bordercolor=black width=300>"
       ."<tr>"
	   ."	<td class=popup>"
       ."   	&nbsp;&nbsp;<b>$linkname</b><br>"
       ."       <li class=popup>";
  	$res .=nl2br($description);
  	$res .=" 		</td>"
	   ."</tr>"
       ."</table>"
       ."</div>";
  	return $res;
}

function prettydate($enddate,$short=false) {
// This function makes the date look more human readable	
	$endyear=substr($enddate, 0, 4);
	$endmonth=substr($enddate, 5, 2);
	$endday=substr($enddate, 8, 2);
	if ($endyear == 0) {
		echo "<i>none</i>";
		return;
	}
	if ($short) {
		echo "$endmonth-$endday-$endyear";
		return;
	}
	switch ($endmonth) {
	case "01":
		$prettymonth="January";
		break;
	case "02":
		$prettymonth="February";
		break;
	case "03":
		$prettymonth="March";
		break;
	case "04":
		$prettymonth="April";
		break;
	case "05":
		$prettymonth="May";
		break;
	case "06":
		$prettymonth="June";
		break;
	case "07":
		$prettymonth="July";
		break;
	case "08":
		$prettymonth="August";
		break;
	case "09":
		$prettymonth="September";
		break;
	case "10":
		$prettymonth="October";
		break;
	case "11":
		$prettymonth="November";
		break;
	case "12":
		$prettymonth="December";
		break;
	}
	echo "$prettymonth $endday, $endyear";
}

function message($message) {
  // writes a pre-formated message to the screen (used for results display)
?>
	<table align=center width=40% border=1 bordercolor=black cellspacing=0 cellpadding=4>
		<tr class=message>
			<td align=center>
				<?=$message?>
			</td>
		</tr>
	</table>
	<br><br>
<?
}


?>
