<?PHP
/*-----------------------------------------------------------------------**
---------------------------------------------------------------------------
IPM (Incyte Project Manager)
PHP based project tracking tool 
Copyright (c) 2001 by phlux

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
---------------------------------------------------------------------------
**-----------------------------------------------------------------------*/

include "config.php";

function verify_ldap_user($username) {
	global $ldap_server,$ldap_port,$ldap_dn,$ldap_attr;
	$ldap=ldap_connect($ldap_server,$ldap_port)
		or die ("Could not connect to LDAP server. Please try again later.");
	if (@ldap_bind($ldap)) {
		// Anonymous bind worked.  Search for user.
		$result=ldap_read($ldap, $ldap_attr."=".$username.",".$ldap_dn, "objectclass=*", array($ldap_attr));
		$usercount=ldap_count_entries($ldap, $result);
		ldap_close($ldap);
		return ($usercount > 0);
	} else {
		message ("Error: Could not bind anonymously to LDAP server");
		return false;
	}
}

function ldap_authenticate($username, $password) {
	global $ldap_server,$ldap_port,$ldap_dn,$ldap_attr;
	$ldap=ldap_connect($ldap_server,$ldap_port)
		or die ("Could not connect to LDAP server. Please try again later.");
	$result=@ldap_bind($ldap,$ldap_attr."=".$username.",".$ldap_dn,$password);
	ldap_close($ldap);
	return ($result==1);
}

?>
