################################################################################
# Set up tables for Incyte Project Manager (IPM)
################################################################################
#IPM (Incyte Project Manager)
#PHP based project tracking tool 
#Copyright (c) 2001 by phlux (phlux@udpviper.com)
################################################################################
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
################################################################################
# host: localhost 
# DB: IPM
################################################################################


# --------------------------------------------------------
#
# Table structure for table 'IPM_comments'
#

DROP TABLE IF EXISTS IPM_comments;
CREATE TABLE IPM_comments (
   comment_id int(10) NOT NULL auto_increment,
   task_id int(10) DEFAULT '0' NOT NULL,
   user int(10),
   date datetime,
   comment text,
   PRIMARY KEY (comment_id)
);


# --------------------------------------------------------
#
# Table structure for table 'IPM_projects'
#

DROP TABLE IF EXISTS IPM_projects;
CREATE TABLE IPM_projects (
   id int(10) NOT NULL auto_increment,
   name text,
   startdate date,
   enddate date,
   comments text,
   completed tinyint(1) DEFAULT '0',
   completed_date date,
   PRIMARY KEY (id)
);


# --------------------------------------------------------
#
# Table structure for table 'IPM_tasks'
#

DROP TABLE IF EXISTS IPM_tasks;
CREATE TABLE IPM_tasks (
   task_id int(10) NOT NULL auto_increment,
   id int(10) DEFAULT '1' NOT NULL,
   title text,
   hours decimal(4,2) DEFAULT '1.00' NOT NULL,
   enddate datetime,
   description text,
   status int(1),
   person int(10) DEFAULT '1' NOT NULL,
   billable tinyint(1) DEFAULT '0' NOT NULL,
   comments tinyint(1) DEFAULT '0' NOT NULL,
   parent_id int(10) DEFAULT '0' NOT NULL,
   priority ENUM('lo','std','hi','crit') DEFAULT 'std' NOT NULL;
   PRIMARY KEY (task_id)
);


# --------------------------------------------------------
#
# Table structure for table 'IPM_users'
#

DROP TABLE IF EXISTS IPM_users;
CREATE TABLE IPM_users (
   id int(10) NOT NULL auto_increment,
   username varchar(30) NOT NULL,
   password varchar(32) NOT NULL,
   firstname text NOT NULL,
   lastname text NOT NULL,
   email varchar(80),
   role int(1) DEFAULT '2' NOT NULL,
   PRIMARY KEY (id)
);


###########################
## INSERT DEFAULT VALUES ##
###########################

INSERT INTO IPM_comments VALUES ( '1', '3', '1', '2002-03-07 00:57:29', 'This task has comments!!!!');
INSERT INTO IPM_comments VALUES ( '2', '3', '1', '2002-03-07 00:57:43', 'The commenting system allows editing of past comments by the original poster or an administrator. The system also automaticaly notes the time of the update. Notice the difference in the original posting time vs. the edited time.<br /><br /> <i>**EDITED BY project -- [Mar 7, 2002 - 12:59:30 AM]</i>');

INSERT INTO IPM_projects VALUES ( '1', 'Example Project', '2002-01-01', '2002-12-31', 'This is simply an example project. You may safely delete it.', '0', '0000-00-00');

INSERT INTO IPM_tasks VALUES ( '1', '1', 'Top level task', '0.00', '0000-00-00 00:00:00', 'This is an example task. It is at the highest level and can be considered a category or a task.', '1', '1', '0', '0', '0');
INSERT INTO IPM_tasks VALUES ( '2', '1', 'Subtask', '3.50', '0000-00-00 00:00:00', 'This task is a subtask. It can have children also. As you can see, you can include <b><font color=FFCC00>HTML</font></b> inside your descriptions.
You can also just press enter to add new lines. This task\'s hours appear in <b>bold</b>, letting you know it is billable. Also notice the ability to add fractional hours.', '1', '1', '1', '0', '1');
INSERT INTO IPM_tasks VALUES ( '3', '1', '3rd level task', '14.00', '0000-00-00 00:00:00', 'This is yet another child task. You can add several tasks on any level. And any task can have children. If you move a task all of its children will follow it.', '1', '1', '0', '1', '2');

INSERT INTO IPM_users VALUES (NULL, 'project', md5('tracker'), 'Project', 'Tracker', 'yourname@yourdomain.com', '1');

