################################################################################
# UPGRADE tables for Incyte Project Manager version 0.8 (IPM)
################################################################################
#IPM (Incyte Project Manager)
#PHP based project tracking tool 
#Copyright (c) 2001 by phlux (phlux@udpviper.com)
################################################################################
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
################################################################################
# host: localhost 
# DB: IPM
################################################################################

#----- UPDATE THE TABLE NAMES
RENAME TABLE projects TO IPM_projects;
RENAME TABLE tasks TO IPM_tasks;
RENAME TABLE users to IPM_users;


#----- UPDATE THE TASKS TABLE
ALTER TABLE IPM_tasks CHANGE enddate enddate DATETIME; 
ALTER TABLE IPM_tasks CHANGE person person INT (10) DEFAULT '1' not null; 
ALTER TABLE IPM_tasks ADD comments TINYINT (1) DEFAULT '0' not null;
ALTER TABLE IPM_tasks ADD parent_id INT (10) DEFAULT '0' not null;
ALTER TABLE IPM_tasks ADD priority ENUM('lo','std','hi','crit') DEFAULT 'std' not null;


#----- UPDATE THE USERS TABLE
ALTER TABLE IPM_users CHANGE password password VARCHAR (32) not null; 


#----- ENCRYPT THE EXISTING PASSWORDS
UPDATE IPM_users SET password=md5(password);


#----- MAKE THE NEW TABLE
CREATE TABLE IPM_comments (
	comment_id int(10) NOT NULL auto_increment,
	task_id int(10) DEFAULT '0' NOT NULL,
	user int(10),
	date datetime,
	comment text,
	PRIMARY KEY (comment_id)
);
